using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using RadGridReportingLite2;
using Telerik.WinControls;

namespace ExampleApplication
{
    public partial class FormMain : RadForm
    {
        public FormMain()
        {
            InitializeComponent();

            this.radGridView1.MasterGridViewTemplate.AllowAddNewRow = false;
        }

        private void FormMain_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < this.adventureWorks_DataSet.Tables.Count; i++)
			{
                RadComboBoxItem item = new RadComboBoxItem(this.adventureWorks_DataSet.Tables[i].TableName);
                item.Value = this.adventureWorks_DataSet.Tables[i].TableName;
                this.radComboBoxTables.Items.Add(item);

                this.radGridView1.Focus();
			}

            this.radGridView1.Select();

            //Telerik.WinControls.RadControlSpy.RadControlSpyForm spy =
            //    new Telerik.WinControls.RadControlSpy.RadControlSpyForm();

            //spy.Show();

            ThemeResolutionService.ApplicationThemeName = "Aqua";
        }

        private void radComboBoxTables_SelectedValueChanged(object sender, EventArgs e)
        {
            this.radComboBoxTables.CloseDropDown();

            if (this.radComboBoxTables.SelectedValue != null)
            {
                //this.radGridView1.DataSource = this.adventureWorks_DataSet;
                //this.radGridView1.DataMember = this.radComboBoxTables.SelectedValue.ToString();

                switch (this.radComboBoxTables.SelectedValue.ToString())
                {
                    case "CountryRegion":
                        this.radGridView1.DataSource = this.adventureWorks_DataSet;
                        this.radGridView1.DataMember = this.radComboBoxTables.SelectedValue.ToString();
                        
                        ExampleApplication.DataBase.AdventureWorks_DataSetTableAdapters.CountryRegionTableAdapter
                            countryRegionAdapter = 
                            new ExampleApplication.DataBase.AdventureWorks_DataSetTableAdapters.CountryRegionTableAdapter();
                        countryRegionAdapter.Fill(this.adventureWorks_DataSet.CountryRegion);

                        this.radGridView1.MasterGridViewTemplate.Columns[0].Width = 140;
                        this.radGridView1.MasterGridViewTemplate.Columns[1].Width = 400;
                        this.radGridView1.MasterGridViewTemplate.Columns[2].Width = 110;
                        this.radGridView1.MasterGridViewTemplate.Columns[2].FormatString = "{0:MM/dd/yyyy}";
                        break;
                    case "Vendor":
                        this.radGridView1.DataSource = this.adventureWorks_DataSet;
                        this.radGridView1.DataMember = this.radComboBoxTables.SelectedValue.ToString();
                        
                        ExampleApplication.DataBase.AdventureWorks_DataSetTableAdapters.VendorTableAdapter
                            vendorAdapter = 
                            new ExampleApplication.DataBase.AdventureWorks_DataSetTableAdapters.VendorTableAdapter();
                        vendorAdapter.Fill(this.adventureWorks_DataSet.Vendor);

                        this.radGridView1.MasterGridViewTemplate.Columns[0].Width = 70;
                        this.radGridView1.MasterGridViewTemplate.Columns[1].Width = 135;
                        this.radGridView1.MasterGridViewTemplate.Columns[2].Width = 250;
                        this.radGridView1.MasterGridViewTemplate.Columns[6].Width = 180;
                        this.radGridView1.MasterGridViewTemplate.Columns[7].Width = 110;
                        this.radGridView1.MasterGridViewTemplate.Columns[7].FormatString = "{0:MM/dd/yyyy}";
                        break;
                    case "Employee":
                        ExampleApplication.DataBase.AdventureWorks_DataSetTableAdapters.EmployeeTableAdapter
                            employeeAdapter =
                            new ExampleApplication.DataBase.AdventureWorks_DataSetTableAdapters.EmployeeTableAdapter();
                        employeeAdapter.Fill(this.adventureWorks_DataSet.Employee);

                        this.radGridView1.DataSource = this.radGridView1.DataSource =
                        //this.adventureWorks_DataSet.Employee.Select("ManagerID = 3 OR ManagerID = 6 OR ManagerID = 7 OR ManagerID = 12");
                        this.adventureWorks_DataSet.Employee.Select("ManagerID = 3 OR ManagerID = 6");
                        
                        //this.radGridView1.DataSource = this.adventureWorks_DataSet.Employee.DefaultView;
                        //this.radGridView1.DataMember = this.radComboBoxTables.SelectedValue.ToString();

                        this.radGridView1.MasterGridViewTemplate.Columns[0].Width = 80;
                        this.radGridView1.MasterGridViewTemplate.Columns[1].Width = 120;
                        this.radGridView1.MasterGridViewTemplate.Columns[2].Width = 70;
                        this.radGridView1.MasterGridViewTemplate.Columns[3].Width = 180;
                        this.radGridView1.MasterGridViewTemplate.Columns[4].Width = 80;
                        this.radGridView1.MasterGridViewTemplate.Columns[5].Width = 220;
                        this.radGridView1.MasterGridViewTemplate.Columns[6].Width = 110;
                        this.radGridView1.MasterGridViewTemplate.Columns[6].FormatString = "{0:MM/dd/yyyy}";
                        this.radGridView1.MasterGridViewTemplate.Columns[7].Width = 70;
                        this.radGridView1.MasterGridViewTemplate.Columns[9].Width = 110;
                        this.radGridView1.MasterGridViewTemplate.Columns[9].FormatString = "{0:MM/dd/yyyy}";
                        this.radGridView1.MasterGridViewTemplate.Columns[14].Width = 110;
                        this.radGridView1.MasterGridViewTemplate.Columns[14].FormatString = "{0:MM/dd/yyyy}";

                        // Group
                        GridGroupByExpression itmGroup = new GridGroupByExpression("ManagerID Group by ManagerID");
                        this.radGridView1.MasterGridViewTemplate.GroupByExpressions.Add(itmGroup);

                        // Summary
                        GridViewSummaryItem summaryItem = new GridViewSummaryItem();
                        summaryItem.FieldName = "ContactID";
                        summaryItem.FormatString = string.Empty;
                        summaryItem.Aggregate = GridAggregateFunction.Sum;

                        GridViewSummaryRowItem summaryRow = new GridViewSummaryRowItem();
                        summaryRow.Add(summaryItem);
                        this.radGridView1.MasterGridViewTemplate.SummaryRowsBottom.Add(summaryRow);

                        break;
                }
            }

        }

        private void radButtonReport_Click(object sender, EventArgs e)
        {
            if (this.radComboBoxTables.SelectedValue != null)
            {
                FormOptions form = new FormOptions();
                ////form.ShowDialog(this);
                ////if (form.DialogResult == DialogResult.OK)
                ////{
                RadGridReportingLite2.RadGridReport2 report =
                        new RadGridReportingLite2.RadGridReport2(string.Format("Report {0}", 
                        this.radComboBoxTables.SelectedValue));
                    report.FitToPageSize = form.FitToPage;
                    report.UseGridColors = form.UseGridColors;
                    report.AllMargins = form.SetAllMargins;
                    report.PaperKind = form.PaperKind;
                    report.PageLandScape = form.IsLandScape;
                    report.ReportWindowState = FormWindowState.Maximized;
                    //ReportWhole.ReportSize = new Size(800, 350);

                    report.CellFont = new Font("Arias", 9f, FontStyle.Regular);
                    report.RepeatTableHeader = form.RepeatHeaderRow;

                    RadLabel lblTitle1 = new RadLabel();
                    lblTitle1.BackColor = System.Drawing.Color.White;
                    lblTitle1.Text = "Title1";
                    lblTitle1.Font = new Font("Arias", 12f, FontStyle.Bold);
                    lblTitle1.TextAlignment = ContentAlignment.MiddleCenter;
                    report.TitleText1 = lblTitle1;

                    RadLabel lblTitle2 = new RadLabel();
                    lblTitle2.BackColor = System.Drawing.Color.White;
                    lblTitle2.Text = "Title2";
                    lblTitle2.Font = new Font("Arias", 12f, FontStyle.Bold);
                    lblTitle2.TextAlignment = ContentAlignment.MiddleCenter;
                    report.TitleText2 = lblTitle2;

                    RadLabel lblTitle3 = new RadLabel();
                    lblTitle3.BackColor = System.Drawing.Color.White;
                    lblTitle3.Text = "Title3";
                    lblTitle3.Font = new Font("Arias", 9.75f, FontStyle.Bold);
                    lblTitle3.TextAlignment = ContentAlignment.MiddleLeft;
                    report.TitleText3 = lblTitle3;

                    RadLabel lblTitle4 = new RadLabel();
                    lblTitle4.BackColor = System.Drawing.Color.White;
                    lblTitle4.Text = "Title4";
                    lblTitle4.Font = new Font("Arias", 9.75f, FontStyle.Bold);
                    lblTitle4.TextAlignment = ContentAlignment.MiddleLeft;
                    report.TitleText4 = lblTitle4;

                    RadLabel lblTitle5 = new RadLabel();
                    lblTitle5.BackColor = System.Drawing.Color.White;
                    lblTitle5.Text = "Title5 (TextAlignment:MiddleRight)";
                    lblTitle5.Font = new Font("Arias", 9.75f, FontStyle.Regular);
                    lblTitle5.TextAlignment = ContentAlignment.MiddleRight;
                    report.TitleText5 = lblTitle5;

                    if (this.radComboBoxTables.SelectedValue.ToString() == "Employee")
                    {
                        // Group
                        report.GroupCaption = new string[] { "ManagerID Caption:" };

                        // String[] { "EmployeeID", "ContactID" }@Summary         Juy.01.09
                        report.SummaryItems = new List<RadGridReportingLite2.Summary_Item>()
                        {
                            new Summary_Item("EmployeeID", "EmployeeID", string.Empty, " records", string.Empty, GridAggregateFunction.Count),
                            new Summary_Item("ContactID", "ContactID", string.Empty, string.Empty, "###,###,##0",GridAggregateFunction.Sum)
                        };
                    }

                    report.ReportFormShow(this, this.radGridView1);
            ////    }
            }
            else
            {
                FormMessage message = new FormMessage("Message",
                    "Please select a table to populate RadGridView!");
                message.ShowDialog(this);
            }

            
        }
    }
}