namespace Telerik.Reporting.KB.CSharp.UserDefinedAggregates
{
    using System.Collections;

    /// <summary>
    /// User-defined aggregate that counts distinct values.
    /// </summary>
    public class CountDistinct
    {
        Hashtable accumulator;

        /// <summary>
        /// Called once when the class is being initialized or reused.
        /// </summary>
        public void Init()
        {
            this.accumulator = new Hashtable();
        }

        /// <summary>
        /// Called once for each row.
        /// </summary>
        /// <param name="value">New value to aggregate by counting distinct.
        /// </param>
        public void Accumulate(object value)
        {
            if (null != value)
            {
                //we need only the key, the value does not matter.
                this.accumulator[value] = "whatever";
            }
        }

        /// <summary>
        /// Returns the result.
        /// </summary>
        /// <returns>The count of distinct values.</returns>
        public int Terminate()
        {
            return this.accumulator.Keys.Count;
        }
    }
}
