namespace Telerik.Reporting.KB.CSharp.UserDefinedAggregates
{
    using System;
    using System.Data;
    using Telerik.Reporting;

    public partial class CountDistinctReport : Report
    {
        CountDistinct totalCountDistinct = new CountDistinct();
        CountDistinct groupCountDistinct = new CountDistinct();
        
        public CountDistinctReport()
        {
            InitializeComponent();
            this.DataSource = DummyDataSource.Generate();
        }

        private void reportHeader_ItemDataBinding(object sender, EventArgs e)
        {
            this.totalCountDistinct.Init();
        }

        private void groupHeader_ItemDataBinding(object sender, EventArgs e)
        {
            this.groupCountDistinct.Init();
        }

        private void detail_ItemDataBound(object sender, EventArgs e)
        {
            Telerik.Reporting.Processing.DetailSection processingDetail = (Telerik.Reporting.Processing.DetailSection) sender;
            DataRowView dataRow = (DataRowView)processingDetail.DataItem;
            object age = dataRow["Age"];
            this.totalCountDistinct.Accumulate(age);
            this.groupCountDistinct.Accumulate(age);
        }

        private void groupFooter_ItemDataBound(object sender, EventArgs e)
        {
            Telerik.Reporting.Processing.GroupSection processingGroupFooter = (Telerik.Reporting.Processing.GroupSection)sender;
            Telerik.Reporting.Processing.TextBox txt = (Telerik.Reporting.Processing.TextBox)processingGroupFooter.Items.Find("gfCountTextBox", false)[0];
            int val = this.groupCountDistinct.Terminate();
            txt.Value = val.ToString();
        }

        private void reportFooter_ItemDataBound(object sender, EventArgs e)
        {
            Telerik.Reporting.Processing.ReportSection processingReportFooter = (Telerik.Reporting.Processing.ReportSection)sender;
            Telerik.Reporting.Processing.TextBox txt = (Telerik.Reporting.Processing.TextBox)processingReportFooter.Items.Find("rfCountTextBox", false)[0];
            int val = this.totalCountDistinct.Terminate();
            txt.Value = val.ToString();
        }
    }
}