namespace Telerik.Reporting.KB.CSharp.UserDefinedAggregates
{
    using System;
    using System.Data;
    using System.Text;

    public static class DummyDataSource
    {
        /// <summary>
        /// Generates a dummy data source
        /// </summary>
        /// <returns>A DataTable with the dummy data source.</returns>
        public static DataTable Generate()
        {
            DataTable dummyDataSource = new DataTable();
            dummyDataSource.Columns.Add("SSN", typeof(int));
            dummyDataSource.Columns.Add("Gender", typeof(string));
            dummyDataSource.Columns.Add("Age", typeof(int));
            Random random = new Random(DateTime.Now.Millisecond);
            for (int i = 0; i < 20; i++)
            {
                int ssn = random.Next(0, 999999999);
                string gender = (random.Next(0, 100) % 2 == 0) ? "Male" : "Female";
                int age;
                if ("Male" == gender)
                {
                    age = random.Next(18, 25);
                }
                else
                {
                    age = random.Next(23, 30);
                }
                dummyDataSource.Rows.Add(ssn, gender, age);
            }
            return dummyDataSource;
        }
    }
}
