using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Data;
using Telerik.ReportViewer.WinForms;
using Telerik.Reporting;
using Telerik.Reporting.Drawing;
using Telerik.WinControls.UI;

namespace RadGridReportingLite2
{
    public class RadGridReport2
    {

        #region Variable, Const, Class

        string REPORT_VIEWER = "ReportViewer";

        // Nov.07.09
        bool c_blnPrintReportFooter = true;
        bool c_blnRepeatTableHeader = false;
        bool c_blnSelectCheck = false;

        string SELECTMARKNAME = "select";
        string[] ca_strGroupCaption = null;

        DataSet reportDataSet;
        System.Drawing.Font c_CellFont = new System.Drawing.Font(new FontFamily("Arial"), 14, FontStyle.Bold);
        Form reportForm;
        FormWindowState windowState;
        Report c_ReportWhole;

        Size reportSize = new Size(800, 600);
        System.Drawing.Printing.PaperKind c_PaperKind = System.Drawing.Printing.PaperKind.A4;

        Unit c_LeftMargin = Unit.Mm(0);
        Unit c_RightMargin = Unit.Mm(0);
        Unit c_TopMargin = Unit.Mm(0);
        Unit c_BottomMargin = Unit.Mm(0);

        enumGroupCaptionDisplayMode c_GroupCaptionDisplayMode = enumGroupCaptionDisplayMode.RemoveTimeSring;
        List<Summary_Item> c_lstSummaryItems = null;

        PageHeaderSection c_PageHeader;
        ReportHeaderSection c_ReportHeader;
        DetailSection c_ReportDetail;
        PageFooterSection c_PageFooter;

        #region for Page Header      Jun.28.09

        double c_dblPageHeader_Height = 29;

        double c_dblReportTitleTextBox1_Height = 0;
        double c_dblReportTitleTextBox2_Height = 0;
        double c_dblReportTitleTextBox3_Height = 0;
        double c_dblReportTitleTextBox4_Height = 0;
        double c_dblReportTitleTextBox5_Height = 0;

        RadLabel c_lblTitle1 = null;
        RadLabel c_lblTitle2 = null;
        RadLabel c_lblTitle3 = null;
        RadLabel c_lblTitle4 = null;
        RadLabel c_lblTitle5 = null;

        Telerik.Reporting.TextBox c_txtTitle1 = null;
        Telerik.Reporting.TextBox c_txtTitle2 = null;
        Telerik.Reporting.TextBox c_txtTitle3 = null;
        Telerik.Reporting.TextBox c_txtTitle4 = null;
        Telerik.Reporting.TextBox c_txtTitle5 = null;

        #endregion

        // Dimension
        int c_intTableHeaderHeight = 0;
        int c_intTableRowsHeight = 0;

        // Declare Total,Group sum-object       Jul.01.09
        //GS.Report.Telerik.AggregateFunction.Sum c_TotalSum = new GS.Report.Telerik.AggregateFunction.Sum();
        List<Summary> c_lstTotalSum = new List<Summary>();
        List<Summary> c_lstGroupSum = new List<Summary>();
 
        // Nov.07.09
        public enum enumGroupCaptionDisplayMode
        {
            None,
            ShowFirstFieldData,       // Caption Fielde()
            RemoveTimeSring,
        }

        #endregion


        #region New, Load, Initial

        public RadGridReport2(string ReportName)
        {
            this.ReportName = ReportName;
            reportDataSet = new DataSet();
        }

        #endregion


        #region Create Report instance and invoke ReporHeader.ItemDataBinding when this.RepeatTableHeader = true)

        void CreateReportForm(string formTitle)
        {
            this.reportForm = new Form();
            this.reportForm.Size = reportSize;
            this.reportForm.WindowState = windowState;

            this.reportForm.StartPosition = FormStartPosition.CenterParent;
            this.reportForm.Font = this.CellFont;
            this.reportForm.FormBorderStyle = FormBorderStyle.Sizable;
            this.reportForm.MinimizeBox = false;
            this.reportForm.Text = formTitle;
            this.reportForm.ShowInTaskbar = false;
            this.reportForm.ShowIcon = false;

            ReportViewer reportViewer = new ReportViewer();
            reportViewer.Dock = DockStyle.Fill;
            reportViewer.Name = REPORT_VIEWER;

            this.reportForm.Controls.Add(reportViewer);
        }
        
        /// <summary>
        /// Create ReportWhole instance and its attributes
        /// Invoke ReporHeader.ItemDataBinding when this.RepeatTableHeader = true
        /// </summary>
        void CreateTelerikReport()
        {
            // 0. Create Report Whole            Mar.11.10
            this.ReportWhole = new Report();

            #region 1. Create Page Header

            c_PageHeader = new PageHeaderSection();
            c_PageHeader.Name = "pageHeader";
            c_PageHeader.ItemDataBinding += new EventHandler(this.PageHeader_ItemDataBinding);             // Jul.01.09

            #region Height of Page Header       Mar.11.10

            double dblPageHeader_Height =  c_dblReportTitleTextBox2_Height + c_dblReportTitleTextBox3_Height +
                                                                            c_dblReportTitleTextBox4_Height + c_dblReportTitleTextBox5_Height;
            if (c_txtTitle1 == null)
            { dblPageHeader_Height += c_dblPageHeader_Height; }
            else
            { dblPageHeader_Height += c_dblReportTitleTextBox1_Height;}

            c_PageHeader.Height = new Unit(dblPageHeader_Height, UnitType.Pixel);

            #endregion

            #region Put ReportTitle, c_txtTitle1, c_txtTitle2, c_txtTitle3, c_txtTitle4, c_txtTitle5 in Page Header  Mar.11.10

            // reportTitleTextBox default
            if (c_txtTitle1 != null)
            { c_PageHeader.Items.Add(c_txtTitle1); }
            else
            {
                Telerik.Reporting.TextBox txtReportTitle = new Telerik.Reporting.TextBox();
                txtReportTitle.Name = "reportTitleTextBox";
                //txtReportTitle.Dock = DockStyle.Top;
                txtReportTitle.Style.Font.Name = this.CellFont.FontFamily.Name;
                txtReportTitle.Style.Font.Style = FontStyle.Bold;
                txtReportTitle.Style.Font.Size = new Unit(14, UnitType.Pixel);
                txtReportTitle.Style.TextAlign = HorizontalAlign.Center;
                txtReportTitle.Value = this.ReportName;
                txtReportTitle.Location = new PointU(new Unit(0, UnitType.Pixel), new Unit(0, UnitType.Pixel));
                txtReportTitle.Size = new SizeU(new Unit(800, UnitType.Pixel), new Unit(c_dblPageHeader_Height, UnitType.Pixel));
                //txtReportTitle.Style.BackgroundColor = System.Drawing.Color.LightCyan;

                c_PageHeader.Items.Add(txtReportTitle);
                //c_PageHeader.Items.AddRange(new Telerik.Reporting.ReportItemBase[] { txtReportTitle });
            }

            if (c_txtTitle2 != null) { this.c_PageHeader.Items.Add(c_txtTitle2); }
            if (c_txtTitle3 != null) { this.c_PageHeader.Items.Add(c_txtTitle3); }
            if (c_txtTitle4 != null) { this.c_PageHeader.Items.Add(c_txtTitle4); }
            if (c_txtTitle5 != null) { this.c_PageHeader.Items.Add(c_txtTitle5); }
            
            #endregion
            
            #endregion

            #region 2. Create Report Detail

            c_ReportDetail = new DetailSection();
            c_ReportDetail.Height = new Unit(c_intTableRowsHeight, UnitType.Pixel);
            c_ReportDetail.Name = "detail";
            c_ReportDetail.ItemDataBound += new EventHandler(this.ReportDetail_ItemDataBound);

            #endregion

            //// Mar.11.10
            //c_ReportDetailChild = new DetailSection();
            //c_ReportDetailChild.Height = new Unit(c_intTableRowsHeight, UnitType.Pixel);
            //c_ReportDetailChild.Name = "detailChild";
            //c_ReportDetailChild.ItemDataBound += new EventHandler(this.ReportDetailChild_ItemDataBound);
     
            #region 3. Create Page Footer

            c_PageFooter = new PageFooterSection();
            c_PageFooter.Height = new Unit(20, UnitType.Pixel);
            c_PageFooter.Name = "pageFooter";

            // currentTimeTextBox, txtPageInfo
            //Telerik.Reporting.TextBox currentTimeTextBox = new Telerik.Reporting.TextBox();
            Telerik.Reporting.TextBox txtPageInfo = new Telerik.Reporting.TextBox();
            txtPageInfo.Dock = DockStyle.Left;
            txtPageInfo.Name = "pageInfoTextBox";
            txtPageInfo.Size = new SizeU(new Unit(100, UnitType.Pixel), new Unit(20, UnitType.Pixel));
            txtPageInfo.Style.TextAlign = HorizontalAlign.Left;
            txtPageInfo.Value = "=PageNumber + ' of '+ PageCount";

            c_PageFooter.Items.AddRange(new Telerik.Reporting.ReportItemBase[] { txtPageInfo });

            #endregion

            #region 4. PageHeader,ReportDetail, PageFooter add to ReportWhole

            ((System.ComponentModel.ISupportInitialize)this.ReportWhole).BeginInit();

            this.ReportWhole.Items.AddRange(new Telerik.Reporting.ReportItemBase[] { c_PageHeader,
                                                                                                                                                            c_ReportDetail,
                                                                                                                                                            c_PageFooter });
            this.ReportWhole.PageSettings.Landscape = this.PageLandScape;
            this.ReportWhole.PageSettings.Margins.Bottom = c_BottomMargin;
            this.ReportWhole.PageSettings.Margins.Left = c_LeftMargin;
            this.ReportWhole.PageSettings.Margins.Right = c_RightMargin;
            this.ReportWhole.PageSettings.Margins.Top = c_TopMargin;
            this.ReportWhole.PageSettings.PaperKind = c_PaperKind;

            #region Add RepeatTableHeader

            c_ReportHeader = new ReportHeaderSection();
            c_ReportHeader.Name = "reportHeader";
            
            // Feb.25.10
            c_ReportHeader.Style.Font.Bold = this.CellFont.Bold;
            c_ReportHeader.Style.Font.Italic = this.CellFont.Italic;
            c_ReportHeader.Style.Font.Name = this.CellFont.Name;
            c_ReportHeader.Style.Font.Size = new Unit(this.CellFont.Size + 2, UnitType.Pixel);
            c_ReportHeader.Style.Font.Strikeout = this.CellFont.Strikeout;
            c_ReportHeader.Style.Font.Underline = this.CellFont.Underline;

            if (c_blnRepeatTableHeader)
            { c_ReportHeader.Height = new Unit(c_intTableHeaderHeight, UnitType.Pixel); }
            else
            { c_ReportHeader.Visible = false; }

            // Invoke ReporHeader.ItemDataBinding
            c_ReportHeader.ItemDataBinding += new EventHandler(this.ReportHeader_ItemDataBinding);

            this.ReportWhole.Items.Add(c_ReportHeader);

            #endregion

            ((System.ComponentModel.ISupportInitialize)this.ReportWhole).EndInit();
            
            #endregion
        }

        #endregion


        #region Page Settings API

        public bool UseGridColors
        {
            get;
            set;
        }

        #endregion


        #region Properties1           Jul.03.09

        /// <summary>
        /// Set ReportWhole's all margins in milimeters
        /// </summary>
        public int AllMargins
        {
            set
            {
                c_TopMargin = Unit.Mm(value);
                c_BottomMargin = Unit.Mm(value);
                c_LeftMargin = Unit.Mm(value);
                c_RightMargin = Unit.Mm(value);
            }
        }

        /// <summary>
        /// Set ReportWhole's bottom margin in milimeters
        /// </summary>
        public int BottomMargin
        {
            set
            {
                c_BottomMargin = Unit.Mm(value);
            }
        }

        /// <summary>
        /// Set ReportWhole to fit to paper size page
        /// </summary>
        public bool FitToPageSize
        {
            get;
            set;
        }

        /// <summary>
        /// Set ReportWhole's left margin in milimeters
        /// </summary>
        public int LeftMargin
        {
            set
            {
                c_LeftMargin = Unit.Mm(value);
            }
        }

        /// <summary>
        /// Set ReportWhole's right margin in milimeters
        /// </summary>
        public int RightMargin
        {
            set
            {
                c_RightMargin = Unit.Mm(value);
            }
        }

        public FormWindowState ReportWindowState
        {
            set
            {
                windowState = value;
            }
        }

        public Size ReportSize
        {
            set { reportSize = value; }
        }

        /// <summary>
        /// Repeat Table header on all pages
        /// </summary>
        public bool RepeatTableHeader
        {
            get { return c_blnRepeatTableHeader; }
            set { c_blnRepeatTableHeader = value; }
        }

        /// <summary>
        /// Get ReportWhole name
        /// </summary>
        public string ReportName
        {
            get;
            set;
        }

        /// <summary>
        /// Get or set the page landscape layout 
        /// </summary>
        public bool PageLandScape
        {
            get;
            set;
        }

        /// <summary>
        /// Get or set paper kind (A3, A4 etc.)
        /// </summary>
        public System.Drawing.Printing.PaperKind PaperKind
        {
            get { return c_PaperKind; }
            set { c_PaperKind = value; }
        }

        /// <summary>
        /// Set ReportWhole's top margin in milimeters
        /// </summary>
        public int TopMargin
        {
            set
            {
                c_TopMargin = Unit.Mm(value);
            }
        }

        #endregion


        #region Properties2           Jun.28.09

        public Report ReportWhole
        {
            get { return c_ReportWhole; }
            set { c_ReportWhole = value; }
        }

        public RadLabel TitleText1
        {
            get { return c_lblTitle1; }
            set 
            { 
                c_lblTitle1 = value;

                // c_ReportTitleText transfer c_ReportTitleTextBox            Jun.28.09
                if (c_txtTitle1 == null) { c_txtTitle1 = new Telerik.Reporting.TextBox(); }
                
                c_dblReportTitleTextBox1_Height = c_lblTitle1.Height;

                // set c_dblPageHeader_Height = 0 if display c_ReportTitleText1,
                c_dblPageHeader_Height = 0;

                this.SetLabelToReportTextBox(c_lblTitle1, c_txtTitle1, "reportTitleTextBox1", 1);
            }
        }

        public RadLabel TitleText2
        {
            get { return c_lblTitle2; }
            set
            {
                c_lblTitle2 = value;

                if (c_txtTitle2 == null) { c_txtTitle2 = new Telerik.Reporting.TextBox(); }
                
                c_dblReportTitleTextBox2_Height = c_lblTitle2.Height;

                this.SetLabelToReportTextBox(c_lblTitle2, c_txtTitle2, "reportTitleTextBox2", c_dblPageHeader_Height + c_dblReportTitleTextBox1_Height);
            }
        }

        public RadLabel TitleText3
        {
            get { return c_lblTitle3; }
            set
            {
                c_lblTitle3 = value;

                if (c_txtTitle3 == null) { c_txtTitle3 = new Telerik.Reporting.TextBox(); }

                c_dblReportTitleTextBox3_Height = c_lblTitle3.Height;

                this.SetLabelToReportTextBox(c_lblTitle3, c_txtTitle3, "reportTitleTextBox3", c_dblPageHeader_Height + c_dblReportTitleTextBox1_Height + c_dblReportTitleTextBox2_Height);
            }
        }

        public RadLabel TitleText4
        {
            get { return c_lblTitle4; }
            set
            {
                c_lblTitle4 = value;

                if (c_txtTitle4 == null) { c_txtTitle4 = new Telerik.Reporting.TextBox(); }

                c_dblReportTitleTextBox4_Height = c_lblTitle4.Height;

                this.SetLabelToReportTextBox(c_lblTitle4, c_txtTitle4, "reportTitleTextBox4", c_dblPageHeader_Height + c_dblReportTitleTextBox1_Height + c_dblReportTitleTextBox2_Height + c_dblReportTitleTextBox3_Height);
            }
        }

        public RadLabel TitleText5
        {
            get { return c_lblTitle5; }
            set
            {
                c_lblTitle5 = value;

                if (c_txtTitle5 == null) { c_txtTitle5 = new Telerik.Reporting.TextBox(); }

                c_dblReportTitleTextBox5_Height = c_lblTitle5.Height;

                this.SetLabelToReportTextBox(c_lblTitle5, c_txtTitle5, "reportTitleTextBox5", c_dblPageHeader_Height + c_dblReportTitleTextBox1_Height + c_dblReportTitleTextBox2_Height + c_dblReportTitleTextBox3_Height + c_dblReportTitleTextBox4_Height);
            }
        }
        
        // Juy.01.09
        public string[] GroupCaption
        {
          get { return ca_strGroupCaption; }
          set { ca_strGroupCaption = value; }
        }

        // Juy.01.09
        public System.Drawing.Font CellFont
        {
            get { return c_CellFont; }
            set { c_CellFont = value; }
        }

        public List<Summary_Item> SummaryItems
        {
            get { return c_lstSummaryItems; }
            set 
            { 
                c_lstSummaryItems = value;

                if (c_lstSummaryItems != null)
                {
                    foreach (Summary_Item summaryItem in c_lstSummaryItems)
                    {
                        c_lstTotalSum.Add(new Summary(summaryItem));
                        c_lstGroupSum.Add(new Summary(summaryItem));
                    }
                }
            }
        }

        // O_CL(ReportFooter)έp            Nov.07.09
        public bool PrintReportFooter
        {
            get { return c_blnPrintReportFooter; }
            set { c_blnPrintReportFooter = value; }
        }

        // GroupCaptionܼҦ     Nov.07.09
        // Default Value: enumGroupCaptionDisplayMode.RemoveTimeSring
        public enumGroupCaptionDisplayMode GroupCaptionDisplayMode
        {
            get { return c_GroupCaptionDisplayMode; }
            set { c_GroupCaptionDisplayMode = value; }
        }

        #endregion


        #region Private Method

        // Jun.28.09
        void SetLabelToReportTextBox(RadLabel TitleText, Telerik.Reporting.TextBox ReportTitleTextBox, string ReportTitleTextBox_Name, Double Location_Y)
        {
            if (string.IsNullOrEmpty(TitleText.Text)) { TitleText.Text = string.Empty; }
            ReportTitleTextBox.Value = TitleText.Text;

            ReportTitleTextBox.Style.Font.Name = this.CellFont.FontFamily.Name;

            if (TitleText.Font.Bold) { ReportTitleTextBox.Style.Font.Style = ReportTitleTextBox.Style.Font.Style | FontStyle.Bold; }
            if (TitleText.Font.Italic) { ReportTitleTextBox.Style.Font.Style = ReportTitleTextBox.Style.Font.Style | FontStyle.Italic; }
            if (TitleText.Font.Underline) { ReportTitleTextBox.Style.Font.Style = ReportTitleTextBox.Style.Font.Style | FontStyle.Underline; }
            if (TitleText.Font.Strikeout) { ReportTitleTextBox.Style.Font.Style = ReportTitleTextBox.Style.Font.Style | FontStyle.Strikeout; }

            ReportTitleTextBox.Style.Color = TitleText.ForeColor;
            ReportTitleTextBox.Style.BackgroundColor = TitleText.BackColor;
            //ReportTitleTextBox.Style.BackgroundImage = TitleText.BackgroundImage;

            ReportTitleTextBox.Style.Font.Size = new Unit(TitleText.Font.Size, UnitType.Pixel);

            ReportTitleTextBox.Name = ReportTitleTextBox_Name;

            //ReportTitleTextBox.Size.Width = new SizeU(new SizeF(TitleText.Width, TitleText.Height));
            ReportTitleTextBox.Location = new PointU(new Unit(0, UnitType.Pixel), new Unit(Location_Y, UnitType.Pixel));

            // 800OHA4Ъ        Jun.28.09
            ReportTitleTextBox.Size = new SizeU(new Unit(800, UnitType.Pixel), new Unit(TitleText.Font.Size, UnitType.Pixel));

            if (TitleText.TextAlignment == ContentAlignment.TopCenter ||
                    TitleText.TextAlignment == ContentAlignment.MiddleCenter ||
                    TitleText.TextAlignment == ContentAlignment.BottomCenter)
            {
                ReportTitleTextBox.Style.TextAlign = HorizontalAlign.Center;
                //ReportTitleTextBox.Style.VerticalAlign = VerticalAlign.Middle;
            }

            if (TitleText.TextAlignment == ContentAlignment.TopRight ||
                    TitleText.TextAlignment == ContentAlignment.MiddleRight ||
                    TitleText.TextAlignment == ContentAlignment.BottomRight)
            {
                ReportTitleTextBox.Style.TextAlign = HorizontalAlign.Right;
            }

            if (TitleText.TextAlignment == ContentAlignment.TopLeft ||
                    TitleText.TextAlignment == ContentAlignment.MiddleLeft ||
                    TitleText.TextAlignment == ContentAlignment.BottomLeft)
            {
                ReportTitleTextBox.Style.TextAlign = HorizontalAlign.Left;
            }
        }

        #endregion


        #region Create Data and Report

        // 1. Calculate Report Width
        // 2. Create Report Header Row
        // 3. Create Report Detail(Table) Items, ReportFooter Items, GroupFooter Items
        // 4. Create Groups and Invoke ItemDataBinding, ItemDataBound
        void AddReportData(RadGridView grid)
        {
            // Jul.01.09
            if (grid == null || (this.reportDataSet.Tables["MasterReportTable"] == null))
            {
                return;
            }

            #region Calculate Report Width

            this.ReportWhole.DataSource = this.reportDataSet.Tables["MasterReportTable"];

            Unit unitReportWidth = Unit.Mm(0);
            double columnWidthSum = 0;

            if (this.FitToPageSize)
            {
                foreach (GridViewDataColumn column in grid.Columns)
                {
                    if (!column.IsGrouped) { columnWidthSum += (double)column.Width; }
                }
            }

            #endregion

            #region Create Group and add to this.ReportWhole        Mar.11.10

            Group unboundGroup = new Group(true);
            unboundGroup.GroupHeader.Height = Unit.Pixel(c_intTableHeaderHeight);
            unboundGroup.GroupHeader.PrintOnEveryPage = true;
            unboundGroup.GroupFooter.Visible = true;

            unboundGroup.GroupHeader.Style.Font.Bold = this.CellFont.Bold;
            unboundGroup.GroupHeader.Style.Font.Italic = this.CellFont.Italic;
            unboundGroup.GroupHeader.Style.Font.Name = this.CellFont.Name;
            unboundGroup.GroupHeader.Style.Font.Size = new Unit(this.CellFont.Size + 2, UnitType.Pixel);
            unboundGroup.GroupHeader.Style.Font.Strikeout = this.CellFont.Strikeout;
            unboundGroup.GroupHeader.Style.Font.Underline = this.CellFont.Underline;

            this.ReportWhole.Groups.Add(unboundGroup);

            #endregion

            Unit reportTableSize;

            if (this.PageLandScape)
            {
                reportTableSize =
                    this.ReportWhole.PageSettings.PaperSize.Height.Subtract(c_LeftMargin).Subtract(c_RightMargin);
            }
            else
            {
                reportTableSize =
                    this.ReportWhole.PageSettings.PaperSize.Width.Subtract(c_LeftMargin).Subtract(c_RightMargin);
            }


            // for ReportFooter and GroupFooter       Jul.01.09
            List<Telerik.Reporting.TextBox> lstReportFooterTextBox = new List<Telerik.Reporting.TextBox>();
            List<Telerik.Reporting.TextBox> lstGroupFooterTextBox = new List<Telerik.Reporting.TextBox>();

            for (int intColIndex = 0; intColIndex < grid.ColumnCount; intColIndex++)
            {
                if (grid.Columns[intColIndex].IsGrouped) { continue; }
                if (grid.Columns[intColIndex].FieldName == SELECTMARKNAME) { continue; }       // Sep.07.08 [J

                #region Create Report Header Row

                GridCellElement headerCell = grid.MasterGridViewInfo.TableHeaderRow.Cells[intColIndex].CellElement;
                if (headerCell == null || headerCell.Text == null) { continue; }        // Sep.07.08 [J

                Telerik.Reporting.TextBox txtCaption = new Telerik.Reporting.TextBox();
                txtCaption.Dock = DockStyle.Left;
                txtCaption.Format = headerCell.FormatString;
                //txtCaption.Name = headerCell.Text + "FieldTextBox";
                txtCaption.Name = headerCell.Text;

                if (this.FitToPageSize)
                { txtCaption.Width = reportTableSize.Multiply(((double)headerCell.Size.Width / columnWidthSum)); }
                else
                { txtCaption.Width = Unit.Pixel(headerCell.Size.Width); }

                txtCaption.Multiline = true;
                txtCaption.TextWrap = true;

                txtCaption.Style.BorderStyle.Default = BorderType.Solid;

                // Create Report Header Cells Colors
                if (this.UseGridColors)
                {
                    txtCaption.Style.BackgroundColor = ColorMixer(headerCell.BackColor, headerCell.BackColor2, headerCell.BackColor3, headerCell.BackColor4);
                    txtCaption.Style.Color = headerCell.ForeColor;
                }
                else
                {
                    txtCaption.Style.BackgroundColor = Color.Gray;
                    txtCaption.Style.Color = Color.White;
                }

                //txtCaption.Style.Font.Name = headerCell.Font.FontFamily.Name;
                txtCaption.Style.Font.Name = this.CellFont.FontFamily.Name;

                //txtCaption.Style.Font.Style = headerCell.Font.Style;
                txtCaption.Style.Font.Size = new Unit(this.CellFont.Size + 2, UnitType.Pixel);
                txtCaption.Style.Font.Style = FontStyle.Regular;
                if (this.CellFont.Bold) { txtCaption.Style.Font.Style = txtCaption.Style.Font.Style | FontStyle.Bold; }
                if (this.CellFont.Italic) { txtCaption.Style.Font.Style = txtCaption.Style.Font.Style | FontStyle.Italic; }
                if (this.CellFont.Underline) { txtCaption.Style.Font.Style = txtCaption.Style.Font.Style | FontStyle.Underline; }
                if (this.CellFont.Strikeout) { txtCaption.Style.Font.Style = txtCaption.Style.Font.Style | FontStyle.Strikeout; }

                txtCaption.Style.TextAlign = this.GetHorisontalAlign(headerCell.TextAlignment);
                //txtCaption.Style.VerticalAlign = VerticalAlign.Middle; 
                txtCaption.Style.VerticalAlign = this.GetVerticalAlign(headerCell.TextAlignment);

                txtCaption.Value = headerCell.Text;

                // Ythis.RepeatTableHeader = true, [JunboundGroup, _h[c_ReportHeader      Mar.11.10
                if (this.RepeatTableHeader)
                { unboundGroup.GroupHeader.Items.Add(txtCaption); }
                else
                { c_ReportHeader.Items.Add(txtCaption); }

                #endregion

                #region Create Report Detail(Table) Items

                Telerik.Reporting.TextBox txtDataRow = new Telerik.Reporting.TextBox();

                txtDataRow.Dock = DockStyle.Left;
                txtDataRow.Format = grid.Columns[intColIndex].FormatString;
                //txtDataRow.Name = "FieldTextBox_" + grid.Columns[intColIndex].FieldName;   // string.Empty;   // grid.Columns[intColIndex].HeaderText + "FieldTextBox";
                txtDataRow.Name = grid.Columns[intColIndex].FieldName;   // string.Empty;   // grid.Columns[intColIndex].HeaderText + "FieldTextBox";
                txtDataRow.Size = txtCaption.Size;
                //txtDataRow.Value = "=Fields." + grid.Columns[intColIndex].HeaderText;
                txtDataRow.Value = "=Fields." + grid.Columns[intColIndex].UniqueName;

                txtDataRow.Style.BorderStyle.Default = BorderType.Ridge;
                txtDataRow.Style.TextAlign = this.GetHorisontalAlign(grid.Columns[intColIndex].TextAlignment);
                //txtDataRow.Style.VerticalAlign = VerticalAlign.Middle;
                txtDataRow.Style.VerticalAlign = this.GetVerticalAlign(grid.Columns[intColIndex].TextAlignment);

                // ]Font
                txtDataRow.Style.Font.Name = this.CellFont.FontFamily.Name;
                txtDataRow.Style.Font.Size = new Unit(this.CellFont.Size + 2, UnitType.Pixel);
                if (this.CellFont.Bold) { txtDataRow.Style.Font.Style = txtDataRow.Style.Font.Style | FontStyle.Bold; }
                if (this.CellFont.Italic) { txtDataRow.Style.Font.Style = txtDataRow.Style.Font.Style | FontStyle.Italic; }
                if (this.CellFont.Underline) { txtDataRow.Style.Font.Style = txtDataRow.Style.Font.Style | FontStyle.Underline; }
                if (this.CellFont.Strikeout) { txtDataRow.Style.Font.Style = txtDataRow.Style.Font.Style | FontStyle.Strikeout; }

                c_ReportDetail.Items.Add(txtDataRow);

                #endregion

                #region O@Detail(Table) Items, Total Footϥ            Jul.01.09

                Telerik.Reporting.TextBox reportFooterTextBox = new Telerik.Reporting.TextBox();

                //reportFooterTextBox.Name = txtDataRow.Name.Replace("FieldTextBox", "TotalFooter");
                reportFooterTextBox.Name = txtDataRow.Name;
                reportFooterTextBox.Size = txtDataRow.Size;
                reportFooterTextBox.Dock = txtDataRow.Dock;
                reportFooterTextBox.Format = txtDataRow.Format;
                reportFooterTextBox.Style.BorderStyle.Bottom = BorderType.Double;
                reportFooterTextBox.Style.Font.Name = txtDataRow.Style.Font.Name;
                reportFooterTextBox.Style.Font.Size = txtDataRow.Style.Font.Size;
                reportFooterTextBox.Style.Font.Style = txtDataRow.Style.Font.Style;
                reportFooterTextBox.Style.TextAlign = txtDataRow.Style.TextAlign;
                //reportFooterTextBox.Style.VerticalAlign = txtDataRow.Style.VerticalAlign;
                reportFooterTextBox.Style.VerticalAlign = VerticalAlign.Bottom;

                lstReportFooterTextBox.Add(reportFooterTextBox);

                #endregion

                #region O@Detail(Table) Items, Group Footϥ            Jul.01.09

                Telerik.Reporting.TextBox dataGroupFooterTextBox = new Telerik.Reporting.TextBox();

                //dataGroupFooterTextBox.Name = txtDataRow.Name.Replace("FieldTextBox", "GroupFooter");
                dataGroupFooterTextBox.Name = txtDataRow.Name;
                dataGroupFooterTextBox.Size = txtDataRow.Size;
                dataGroupFooterTextBox.Dock = txtDataRow.Dock;
                dataGroupFooterTextBox.Format = txtDataRow.Format;
                //dataGroupFooterTextBox.Style.BorderStyle.Bottom = BorderType.Double;
                dataGroupFooterTextBox.Style.Font.Name = txtDataRow.Style.Font.Name;
                dataGroupFooterTextBox.Style.Font.Size = txtDataRow.Style.Font.Size;
                dataGroupFooterTextBox.Style.Font.Style = txtDataRow.Style.Font.Style;
                dataGroupFooterTextBox.Style.TextAlign = txtDataRow.Style.TextAlign;
                //dataGroupFooterTextBox.Style.VerticalAlign = txtDataRow.Style.VerticalAlign;
                dataGroupFooterTextBox.Style.VerticalAlign = VerticalAlign.Top;

                lstGroupFooterTextBox.Add(dataGroupFooterTextBox);

                #endregion

                // pWidth        Jul.01.09
                unitReportWidth = unitReportWidth.Add(txtDataRow.Width);

            }   // for (int intColIndex = 0...

            this.ReportWhole.Width = unitReportWidth;

            #region GROUPS

            for (int i = 0; i < grid.MasterGridViewTemplate.GroupByExpressions.Count; i++)
            {
                Group group = new Group(true);

                group.GroupHeader.Height = Unit.Pixel(c_intTableHeaderHeight);
                group.GroupHeader.KeepTogether = true;
                // Group Header SectionItemDataBindingƥ      Jul.01.09
                group.GroupHeader.ItemDataBinding += new EventHandler(this.GroupHeader_ItemDataBinding);

                group.GroupFooter.Height = Unit.Pixel(c_intTableHeaderHeight + 10);
                //group.GroupFooter.Visible = true;
                // Group Footer SectionItemDataBindingƥ      Jul.01.09
                group.GroupFooter.ItemDataBound += new EventHandler(this.GroupFooter_ItemDataBound);

                #region Group Header Caption

                group.Grouping.Add(string.Format("=Fields.{0}",
                    grid.MasterGridViewTemplate.GroupByExpressions[i].SelectFields[0].FieldName));

                Telerik.Reporting.TextBox groupTitleTextBox = new Telerik.Reporting.TextBox();
                groupTitleTextBox.Dock = DockStyle.Fill;
                //groupTitleTextBox.Width = unitReportWidth;
                groupTitleTextBox.Style.Font.Style = FontStyle.Bold;
                groupTitleTextBox.Style.VerticalAlign = VerticalAlign.Bottom;

                groupTitleTextBox.Style.Font.Bold = this.CellFont.Bold;
                groupTitleTextBox.Style.Font.Italic = this.CellFont.Italic;
                groupTitleTextBox.Style.Font.Name = this.CellFont.Name;
                groupTitleTextBox.Style.Font.Size = new Unit(this.CellFont.Size + 2, UnitType.Pixel);
                groupTitleTextBox.Style.Font.Strikeout = this.CellFont.Strikeout;
                groupTitleTextBox.Style.Font.Underline = this.CellFont.Underline;

                for (int j = 0; j < grid.MasterGridViewTemplate.GroupByExpressions[i].SelectFields.Count; j++)
                {
                    if (this.GroupCaption != null && j < this.GroupCaption.Length)
                    {
                        if (this.GroupCaptionDisplayMode == enumGroupCaptionDisplayMode.RemoveTimeSring)
                        {
                            // R"W 12:00:00"            Jul.02.09
                            groupTitleTextBox.Value = String.Format("=\"{0} \" + CStr(IsNull(Fields.[{1}],\"\")).Replace(\"W 12:00:00\",\"\")",
                                                                                                            this.GroupCaption[j],
                                                                                                            grid.MasterGridViewTemplate.GroupByExpressions[i].SelectFields[j].FieldName);
                            // uBzĤ@Group        Jun.30.09
                            break;
                        }
                        else if (this.GroupCaptionDisplayMode == enumGroupCaptionDisplayMode.ShowFirstFieldData)   // ܲĤ@Caption Fielde()
                        {
                            groupTitleTextBox.Value = String.Format("=Fields.{0}", grid.MasterGridViewTemplate.GroupByExpressions[i].SelectFields[j].FieldName);
                        }
                    }
                }

                // [JGroup HeaderCaption
                group.GroupHeader.Items.Add(groupTitleTextBox);

                #endregion

                #region NTextBoxes[JGroup Footer    Jul.01.09

                for (int intIndex = 0; intIndex < lstGroupFooterTextBox.Count; intIndex++)
                {
                    group.GroupFooter.Items.Add(lstGroupFooterTextBox[intIndex]);
                }

                #endregion

                this.ReportWhole.Groups.Add(group);
            }

            #endregion

            GroupFooterSection groupFooter = unboundGroup.GroupFooter;

            // 󦹳]wReport Footer(unboundGroup.GroupFooter)
            // ]be~c_lstTotalFooterTextBox
            groupFooter.Height = Unit.Pixel(c_intTableHeaderHeight + 10);
            groupFooter.ItemDataBound += new EventHandler(this.ReportFooter_ItemDataBound);

            for (int intIndex = 0; intIndex < lstReportFooterTextBox.Count; intIndex++)
            {
                groupFooter.Items.Add(lstReportFooterTextBox[intIndex]);
            }
        }

        /// <summary>
        /// Genarate a DataSet from RadGridView data
        /// </summary>
        /// <param name="grid">Source RadGridView</param>
        void CreateDataSet(RadGridView grid)
        {
            DataTable masterTable = this.CreateTableFromTemplate(grid.MasterGridViewTemplate, "MasterReportTable");
            
            //Export to ExcelML: summary rows are now included in the exported file through a new SummariesExportOption property. It takes the following values: ExportAll (default one), ExportOnlyTop, ExportOnlyBottom, DoNotExport ; 

            //MessageBox.Show(grid.MasterGridViewTemplate.SummaryRowsBottom.Count.ToString(), "1");
            //for (int intColIndex = 0; intColIndex < grid.MasterGridViewTemplate.SummaryRowsBottom.Count; intColIndex++)
            //{
            //    GridViewSummaryRowInfo siRowInfo = grid.MasterGridViewTemplate.SummaryRowsBottom[intColIndex] as GridViewSummaryRowInfo;
            //    MessageBox.Show(((GridSummaryCellElement)grid.MasterGridViewInfo.SystemRows[intColIndex].Cells[0].CellElement).Text,"2");
            //    if (siRowInfo != null)
            //    {
            //        DataRow drSummaryRow = masterTable.NewRow();
            //        MessageBox.Show(grid.MasterGridViewInfo.SystemRows.Count.ToString(), "grid.MasterGridViewInfo.SystemRows.Count.ToString()");
            //        for (int j = 0; j < siRowInfo.Cells.Count; j++)
            //        {
            //            MessageBox.Show(siRowInfo.Cells[j].Value.ToString());
            //        }
            //    }
            //}

            this.reportDataSet.Tables.Add(masterTable);
        }

        /// <summary>
        /// Create DataTable form GridViewTemplate
        /// </summary>
        /// <param name="gridViewTemplate">GridViewTemplate which contains data</param>
        /// <param name="tableName">Table name</param>
        /// <returns>DataTable which contains data from GridViewTemplate</returns>
        DataTable CreateTableFromTemplate(GridViewTemplate gridViewTemplate, string tableName)
        {
            if (gridViewTemplate == null || string.IsNullOrEmpty(tableName)) { return null; }
            
                List<int> lstHeaderReplicate = new List<int>();

                #region Create Print DataTable

                DataTable dtPrintDataTable = new DataTable(tableName);
                
                for (int col = 0; col < gridViewTemplate.ColumnCount; col++)
                {
                    gridViewTemplate.Columns[col].HeaderText = gridViewTemplate.Columns[col].HeaderText.Replace(" ", "");

                    // Columns: SELECTMARKNAME must be hidden
                    if (gridViewTemplate.Columns[col].FieldName == SELECTMARKNAME)
                    {
                        c_blnSelectCheck = true;
                        lstHeaderReplicate.Add(col);
                        continue;
                    }
                    
                    //lstHeaderText.Add(gridViewTemplate.Columns[col].HeaderText);
                    //dtPrintDataTable.Columns.Add(gridViewTemplate.Columns[col].HeaderText, gridViewTemplate.Columns[col].DataType);
                    dtPrintDataTable.Columns.Add(gridViewTemplate.Columns[col].UniqueName, gridViewTemplate.Columns[col].DataType);
                }

                #endregion

                bool blnSelect;
                int intColIndex;

                for (int row = 0; row < gridViewTemplate.RowCount; row++)
                {
                    #region add Column:SELECTMARKNAME by c_blnSelectCheck

                    if (c_blnSelectCheck)
                    {
                        if (bool.TryParse(gridViewTemplate.Rows[row].Cells[SELECTMARKNAME].Value.ToString(), out blnSelect))
                        {
                            if (!blnSelect) { continue; }
                        }
                        else
                        { continue; }
                    }

                    #endregion

                    #region add new row

                    DataRow drPrintTarget = dtPrintDataTable.NewRow();

                    intColIndex = 0;
                    for (int intCellIndex = 0; intCellIndex < gridViewTemplate.ColumnCount; intCellIndex++)
                    {
                        // check replicate Column
                        if (lstHeaderReplicate.Contains(intCellIndex)) { continue; }

                        try
                        {
                            drPrintTarget[intColIndex] = gridViewTemplate.Rows[row].Cells[intCellIndex].Value;
                        }
                        catch { }

                        intColIndex++;
                    }

                    dtPrintDataTable.Rows.Add(drPrintTarget);

                    #endregion
                }

                return dtPrintDataTable;
        }

        #endregion


        #region Private Method

        /// <summary>
        /// Color blend fuction to mix several colors
        /// </summary>
        /// <param name="colors">Color to include in mixer</param>
        /// <returns>Blended colors</returns>
        Color ColorMixer(params Color[] colors)
        {
            int colorR = 0;
            int colorG = 0;
            int colorB = 0;

            for (int i = 0; i < colors.Length; i++)
            {
                colorR += colors[i].R;
                colorG += colors[i].G;
                colorB += colors[i].B;
            }

            colorR = colorR / colors.Length;
            colorG = colorG / colors.Length;
            colorB = colorB / colors.Length;

            Color mixedColor = Color.FromArgb(colorR, colorG, colorB);

            return mixedColor;
        }

        /// <summary>
        /// Get Header and Row sizes for Report from provided RadGridView
        /// </summary>
        /// <param name="grid">Source RadGridView</param>
        void GetGridDimensions(RadGridView grid)
        {
            c_intTableHeaderHeight =
                ((GridTableHeaderRowElement)(grid.RootElement.Children[0].Children[1].Children[0])).Size.Height;

            c_intTableRowsHeight = this.GetRowAverageHeight(grid);
        }

        /// <summary>
        /// Get average DataRows height
        /// </summary>
        /// <param name="grid">Source RadGridView</param>
        /// <returns>Average height</returns>
        int GetRowAverageHeight(RadGridView grid)
        {
            int rowHeightSum = 0;
            int rowSum = 0;

            for (int i = 0; i < grid.RowCount; i++)
            {
                rowHeightSum += grid.Rows[i].GetActualHeight(grid.GridElement);
                rowSum++;
            }

            int childTemplatesCount = grid.MasterGridViewTemplate.ChildGridViewTemplates.Count;

            for (int i = 0; i < childTemplatesCount; i++)
			{
                int rowCount = grid.MasterGridViewTemplate.ChildGridViewTemplates[i].RowCount;
                for (int j = 0; j < rowCount; j++)
                {
                    rowHeightSum += grid.MasterGridViewTemplate.ChildGridViewTemplates[i].Rows[j].GetActualHeight(grid.GridElement);
                    rowSum++;
                }
			}

            int averageHeight = 0;
            if (rowSum > 0) { averageHeight = rowHeightSum / rowSum; }

            int height = 20;
            if (averageHeight > 0) { height = averageHeight; } 
          
            return height;
        }

        HorizontalAlign GetHorisontalAlign(ContentAlignment align)
        {
            if ((align == ContentAlignment.BottomRight) || 
                (align == ContentAlignment.MiddleRight) ||
                (align == ContentAlignment.TopRight))
            {
                return HorizontalAlign.Right;
            }
            else if ((align == ContentAlignment.BottomLeft) ||
                        (align == ContentAlignment.MiddleLeft) ||
                        (align == ContentAlignment.TopLeft))
            {
                return HorizontalAlign.Left;
            }
            else 
            {
                return HorizontalAlign.Center;
            }
        }

        VerticalAlign GetVerticalAlign(ContentAlignment align)
        {
            if ((align == ContentAlignment.BottomCenter) ||
                (align == ContentAlignment.BottomLeft) ||
                (align == ContentAlignment.BottomRight))
            {
                return VerticalAlign.Bottom;
            }
            else if ((align == ContentAlignment.TopCenter) ||
                        (align == ContentAlignment.TopLeft) ||
                        (align == ContentAlignment.TopRight))
            {
                return VerticalAlign.Top;
            }
            else
            {
                return VerticalAlign.Middle;
            }
        }
        
        #endregion


        #region Public Method

        /// <summary>
        /// Create and show a form containig ReportWhole
        /// </summary>
        /// <param name="owner">The owner of ReportWhole form</param>
        /// <param name="radGridView">The grid which will be present in ReportWhole</param>
        public void ReportFormShow(IWin32Window owner, RadGridView radGridView)
        {
            // 0. Get Header and Row sizes for Report from provided RadGridView
            this.GetGridDimensions(radGridView);

            // 1. Windown Form, å[JReportViewer       Mar.11.10
            this.CreateReportForm(this.ReportName);
            
            // 2. ReortWhole, ̧ǥ[JPageHeader, ReportDetail, PageFooter, ReportHeader      Mar.11.10
            this.CreateTelerikReport();
            
            // 3.  radGridView.MasterGridViewTemplate, onCLDataTable, éJreportDataSet    Mar.11.10
            this.CreateDataSet(radGridView);

            // 1. Calculate Report Width
            // 2. Create Report Header Row
            // 3. Create Report Detail(Table) Items, ReportFooter Items, GroupFooter Items
            // 4. Create Groups and Invoke ItemDataBinding, ItemDataBound
            this.AddReportData(radGridView);

            //Telerik.Reporting.Processing.ReportProcessor.ListRenderingExtensions();
            //Telerik.Reporting.Processing.ReportProcessor.Render(
            //Telerik.Reporting.Processing.ReportProcessor.Render(  reportProcessor = new Telerik.Reporting.Processing.ReportProcessor();
            ////Telerik.Reporting.Processing.ReportProcessor.Print(this.ReportWhole, null);

            ((ReportViewer)reportForm.Controls[REPORT_VIEWER]).Font = this.CellFont;     // Feb.25.10  this.CellFont@
            ((ReportViewer)reportForm.Controls[REPORT_VIEWER]).ShowRefreshButton = false;
            ((ReportViewer)reportForm.Controls[REPORT_VIEWER]).ShowZoom = true;
            ((ReportViewer)reportForm.Controls[REPORT_VIEWER]).Report = this.ReportWhole;
            ((ReportViewer)reportForm.Controls[REPORT_VIEWER]).RefreshReport();

            reportForm.ShowDialog(owner);
        }
        
        #endregion


        #region Report Event

        // Jul.01.09
        void GroupFooter_ItemDataBound(object sender, EventArgs e)
        {
            Telerik.Reporting.Processing.GroupSection processingGroupFooter = (Telerik.Reporting.Processing.GroupSection)sender;

            for (int intIndex = 0; intIndex < c_lstGroupSum.Count; intIndex++)
            {
                if (c_lstGroupSum[intIndex].AggregateFunction == GridAggregateFunction.None) { continue; }

                // FieldNameXTextBox, AwValue(c_lstGroupSum[intIndex].Result)
                Telerik.Reporting.Processing.ReportItemBase[] a_reportItemBase = processingGroupFooter.Items.Find(c_lstGroupSum[intIndex].FieldName, false);

                if (a_reportItemBase != null && a_reportItemBase.Length > 0)
                {
                    Telerik.Reporting.Processing.TextBox dataTextBox = (Telerik.Reporting.Processing.TextBox)a_reportItemBase[0];
                    dataTextBox.Value = c_lstGroupSum[intIndex].HeaderText + c_lstGroupSum[intIndex].Result.ToString(c_lstGroupSum[intIndex].FormatString) + c_lstGroupSum[intIndex].FooterText;
                }
            }   // for
        }

        // Jul.01.09
        void GroupHeader_ItemDataBinding(object sender, EventArgs e)
        {
            for (int intIndex = 0; intIndex < c_lstGroupSum.Count; intIndex++)
            {
                c_lstGroupSum[intIndex].Initial(0);
            }
        }

        // Jul.01.09
        void PageHeader_ItemDataBinding(object sender, EventArgs e)
        {
            // Cs@, c_TotalSum.ResultNiQM0
            //c_TotalSum.Initial(0);
        }

        // Mar.11.10
        void ReportDetailChild_ItemDataBound(object sender, EventArgs e)
        {
        }

        // Jul.01.09
        void ReportDetail_ItemDataBound(object sender, EventArgs e)
        {
            Telerik.Reporting.Processing.DetailSection processingDetail = (Telerik.Reporting.Processing.DetailSection)sender;
            DataRowView dataRow = (DataRowView)processingDetail.DataItem;

            for (int intIndex = 0; intIndex < c_lstGroupSum.Count; intIndex++)
            {
                decimal decValue = 0;
                if (!decimal.TryParse(dataRow[c_lstGroupSum[intIndex].FieldName].ToString(), out decValue)) { continue; }

                // implement SUM, COUNT function...
                c_lstTotalSum[intIndex].Accumulate(decValue);
                c_lstGroupSum[intIndex].Accumulate(decValue);
            }
        }

        // Jul.01.09
        void ReportFooter_ItemDataBound(object sender, EventArgs e)
        {
            if (!this.PrintReportFooter) { return; }

            Telerik.Reporting.Processing.GroupSection ReportFooter = (Telerik.Reporting.Processing.GroupSection)sender;

            for (int intIndex = 0; intIndex < c_lstTotalSum.Count; intIndex++)
            {
                if (c_lstTotalSum[intIndex].AggregateFunction == GridAggregateFunction.None) { continue; }

                Telerik.Reporting.Processing.ReportItemBase[] a_reportItemBase = ReportFooter.Items.Find(c_lstTotalSum[intIndex].FieldName, false);

                if (a_reportItemBase != null && a_reportItemBase.Length > 0)
                {
                    Telerik.Reporting.Processing.TextBox dataTextBox = (Telerik.Reporting.Processing.TextBox)a_reportItemBase[0];
                    dataTextBox.Value = c_lstTotalSum[intIndex].HeaderText + c_lstTotalSum[intIndex].Result.ToString(c_lstTotalSum[intIndex].FormatString) + c_lstTotalSum[intIndex].FooterText;
                }
            }   // for
        }

        // Jul.01.09
        void ReportHeader_ItemDataBinding(object sender, EventArgs e)
        {
            for (int intIndex = 0; intIndex < c_lstTotalSum.Count; intIndex++)
            {
                c_lstTotalSum[intIndex].Initial(0);
            }
        }

        #endregion
    }
}
